#include <stdio.h>

#define MAXPIX 1024

unsigned char pixmap[MAXPIX][3][MAXPIX];       /* image RAW */

unsigned char bitmap[3][MAXPIX][MAXPIX];        /* bit-map image INFOROP */
unsigned char nbchannels;

char commande[80];

strd(dest, orig)
char *dest, *orig ;
{
  int i = 4 ;
  while (i--) *dest++ = *orig++ ;
}

main(argc,argv)

int argc;
char * argv[];
{
  /* Les noms des fichiers utilises */

  static char   NomFic[80];
  static char   NomFicIn[80];
  static char   NomRes[80]; 

  FILE * FicIn, * Res;

  unsigned short nblig, nbcol, nbpla = 3 ;
  int l, c, p;
  short i,j;
  char entete[1024] ;


  if(argc != 2){
    printf("Le nombre de parametres est incorrect\n");
    exit(1);
  }


  strcpy(NomFicIn,*(argv + 1));
  
  /* Construction du nom des fichiers */

  strcpy(NomRes,NomFicIn); strcat(NomRes,".it");

  /* Ouverture des fichiers */

  if((FicIn=fopen(NomFicIn,"r")) == NULL){
    fprintf(stderr,"Impossible d'ouvrir %s en lecture \n",NomFicIn);
    exit(1);
  }

  if((Res=fopen(NomRes,"w")) == NULL){
         printf("Impossible d'ouvrir %s en ecriture\n",NomRes);
         exit(1);
       }

  fread(&nbchannels, 1, 1, FicIn);
  fread((char *)&nbcol+1, 1, 1, FicIn);
  fread(&nbcol, 1, 1, FicIn);
  fread((char *)&nblig+1, 1, 1, FicIn);
  fread(&nblig, 1, 1, FicIn);
  l = (int)nblig; c = (int)nbcol; p = (int)nbpla;
  fprintf(stderr,"%s %s %d %d %d\n",NomFicIn, NomRes, nbchannels, nbcol,nblig);
  for(i=0;i<nblig;i++){
    fread(pixmap[i][0], nbcol*sizeof(unsigned char), 1, FicIn);
    fread(pixmap[i][1], nbcol*sizeof(unsigned char), 1, FicIn);
    fread(pixmap[i][2], nbcol*sizeof(unsigned char), 1, FicIn);
  }

  /* conversion RAW --> Inforop */

  for(i=0;i<nblig;i++)
  {
      for(j=0;j<nbcol;j++)
      {
	  bitmap[0][i][j]=pixmap[i][0][j];
	  bitmap[1][i][j]=pixmap[i][1][j];
	  bitmap[2][i][j]=pixmap[i][2][j];
      }
  }

  /* ecriture fichier resultat */

  strcpy(entete, "ITRILABEL") ;
  strd(entete+68, (char *) &l) ;
  strd(entete+72, (char *) &c) ;
  strd(entete+76, (char *) &p) ;
  fwrite(entete, nbcol, 1, Res) ;

  for (i=0;i<nblig;i++)
  fwrite(bitmap[0][i], nbcol*sizeof(unsigned char), 1, Res);
  for (i=0;i<nblig;i++)
  fwrite(bitmap[1][i], nbcol*sizeof(unsigned char), 1, Res); 
  for (i=0;i<nblig;i++)
  fwrite(bitmap[2][i], nbcol*sizeof(unsigned char), 1, Res);
  
  /* Fermeture des fichiers */

  fclose(FicIn);
  fclose(Res);
   sprintf(commande,"/bin/rm %s", NomFicIn);
     system(commande);

  

  printf("Fin de la conversion\n");

}



