/***********************************************************************
 * $Log:	extern.h,v $
 * Revision 1.2  88/09/12  13:11:13  markv
 * Added extern definition for nShadowCacheHits
 * 
 * Revision 1.1  88/09/11  11:00:49  markv
 * Initial revision
 * 
 ***********************************************************************/

extern  Tnommat         * nommat;
extern  Tparamphys      * paramphys;
extern  int             nmat;

extern  entier          nsamples;
extern  SplePt          * sample;
extern  boite           * D3grid;
extern  boite           * grille;

extern  visibilite      * visgraph;
extern  Flt             freqmin;

extern  Flt             MINLIGHT;
extern  int             LGMAX;
extern  SolidAngle      solang[];

extern  int             RESXYZ[];
extern  int             NBOITES;
extern  int             nboites;
extern  int             NBARCS;
extern  int             deb,fin;
extern  char            *graphname;
extern  int             maxiter;

extern  boite*          SI[NIV_2N_MAX][NIV_2N_MAX][NIV_2N_MAX];
extern  Flt             MINSURF;
extern  int             MAXNIV;

extern  spectral        lgd,dlgd;

extern  int             resolutionflag;
extern  int 		yylinecount ;
extern	Viewpoint 	Eye ;
extern	int 		Xresolution ;
extern	int 		Yresolution ;
/*extern	Light		Lights[] ;*/
extern	int		nLights ;
extern	spectral	BackgroundColor ;
extern	Surface		* CurrentSurface ;
extern	Object		* Prims[] ;
extern	int		nPrims ;
extern 	Flt		rayeps ;
extern	char *		Progname ;
extern 	int		maxQueueSize ;
extern 	int		totalQueues ;
extern	int		totalQueueResets ;
extern 	int		tickflag ;
extern  int		nChecked ;
extern 	int		nEnqueued ;
extern  int		nShadowCacheHits ;

extern 	Flt		minweight ;
extern 	int		maxlevel ;
extern 	int		nRays ;
extern	int		nShadows ;
extern	int		nReflected ;
extern 	int		nRefracted ;

extern  char *          memset() ;
extern 	char *		malloc() ;
extern 	char *          realloc();
extern 	char *		calloc() ;
extern 	char *		rindex() ;
extern 	char *          memcpy() ;
extern  char *          strcpy();
extern  char *          strcat();     
  
extern  int     free();
extern  void    exit();
extern  double  sqrt();
extern  double  pow();
extern  double  sin();
extern  double  cos();
extern  double  atan();
extern  double  tan();
extern  double  acos();

extern	Object *	MakeCone() ;
extern	Object *	MakeSphere() ;
extern	Object *	MakePatch() ;
extern	Object *	MakePoly() ;
extern	Object *	MakeCylinder() ;
extern	Object *	MakeTri() ;
extern 	Flt		VecNormalize() ;
extern	Vec		Slab[] ;
extern	ObjectProcs	NullProcs ;
extern 	Object *	Root ;

extern  void            StartChrono();
extern  void            StopChrono();

#ifdef DUMB_CPP

extern Flt	VecDot() ;
extern Flt 	VecLen() ;

#endif /* DUMB_CPP */
